diff -Naur gcc-9.5.0/isl-0.18/isl_schedule_tree.h.rej gcc-9.5.0-irix/isl-0.18/isl_schedule_tree.h.rej
--- gcc-9.5.0/isl-0.18/isl_schedule_tree.h.rej	1969-12-31 19:00:00.000000000 +0000
+++ gcc-9.5.0-irix/isl-0.18/isl_schedule_tree.h.rej	2024-12-22 11:54:26.488072000 +0000
@@ -0,0 +1,17 @@
+--- isl_schedule_tree.h	2016-12-12 09:15:44.000000000 +0000
++++ isl_schedule_tree.h	2019-05-30 19:16:57.974657440 +0000
+@@ -63,12 +63,12 @@
+ 		struct {
+ 			isl_union_pw_multi_aff *contraction;
+ 			isl_union_map *expansion;
+-		};
++		} anonstruct;
+ 		isl_union_map *extension;
+ 		isl_union_set *filter;
+ 		isl_set *guard;
+ 		isl_id *mark;
+-	};
++	} anonunion;
+ 	isl_schedule_tree_list *children;
+ };
+ 
diff -Naur gcc-9.5.0/isl-0.18/isl_test.c gcc-9.5.0-irix/isl-0.18/isl_test.c
--- gcc-9.5.0/isl-0.18/isl_test.c	2016-12-15 06:27:30.000000000 +0000
+++ gcc-9.5.0-irix/isl-0.18/isl_test.c	2024-12-22 11:54:48.335515200 +0000
@@ -493,18 +493,22 @@
 	return 0;
 }
 
-struct {
+struct vbo {
 	__isl_give isl_val *(*fn)(__isl_take isl_val *v1,
 				__isl_take isl_val *v2);
-} val_bin_op[] = {
-	['+'] = { &isl_val_add },
-	['-'] = { &isl_val_sub },
-	['*'] = { &isl_val_mul },
-	['/'] = { &isl_val_div },
-	['g'] = { &isl_val_gcd },
-	['m'] = { &isl_val_min },
-	['M'] = { &isl_val_max },
-};
+} vbo;
+struct vbo val_bin_op[256];
+
+void setup_val_bin_ops()
+{
+  val_bin_op['+'].fn=&isl_val_add;
+  val_bin_op['-'].fn=&isl_val_sub;
+  val_bin_op['*'].fn=&isl_val_mul;
+  val_bin_op['/'].fn=&isl_val_div;
+  val_bin_op['g'].fn=&isl_val_gcd;
+  val_bin_op['m'].fn=&isl_val_min;
+  val_bin_op['M'].fn=&isl_val_max;
+}
 
 struct {
 	const char *arg1;
@@ -4344,14 +4348,18 @@
 	return 0;
 }
 
-struct {
+struct abo {
 	__isl_give isl_aff *(*fn)(__isl_take isl_aff *aff1,
 				__isl_take isl_aff *aff2);
-} aff_bin_op[] = {
-	['+'] = { &isl_aff_add },
-	['-'] = { &isl_aff_sub },
-	['*'] = { &isl_aff_mul },
-	['/'] = { &isl_aff_div },
+} abo;
+struct abo aff_bin_op[256];
+
+void setup_aff_bin_ops()
+{
+  aff_bin_op['+'].fn=&isl_aff_add;
+  aff_bin_op['-'].fn=&isl_aff_sub;
+  aff_bin_op['*'].fn=&isl_aff_mul;
+  aff_bin_op['/'].fn=&isl_aff_div;
 };
 
 struct {
@@ -6943,6 +6951,9 @@
 	struct isl_ctx *ctx;
 	struct isl_options *options;
 
+	setup_val_bin_ops();
+	setup_aff_bin_ops();
+
 	options = isl_options_new_with_defaults();
 	assert(options);
 	argc = isl_options_parse(options, argc, argv, ISL_ARG_ALL);
diff -Naur gcc-9.5.0/isl-0.18/isl_test.c.rej gcc-9.5.0-irix/isl-0.18/isl_test.c.rej
--- gcc-9.5.0/isl-0.18/isl_test.c.rej	1969-12-31 19:00:00.000000000 +0000
+++ gcc-9.5.0-irix/isl-0.18/isl_test.c.rej	2024-12-22 11:54:27.424405600 +0000
@@ -0,0 +1,70 @@
+--- isl_test.c	2016-12-15 11:27:30.000000000 +0000
++++ isl_test.c	2019-05-30 19:29:59.117169440 +0000
+@@ -493,18 +493,22 @@
+ 	return 0;
+ }
+ 
+-struct {
++struct vbo {
+ 	__isl_give isl_val *(*fn)(__isl_take isl_val *v1,
+ 				__isl_take isl_val *v2);
+-} val_bin_op[] = {
+-	['+'] = { &isl_val_add },
+-	['-'] = { &isl_val_sub },
+-	['*'] = { &isl_val_mul },
+-	['/'] = { &isl_val_div },
+-	['g'] = { &isl_val_gcd },
+-	['m'] = { &isl_val_min },
+-	['M'] = { &isl_val_max },
+-};
++} vbo;
++struct vbo val_bin_op[256];
++
++void setup_val_bin_ops()
++{
++  val_bin_op['+'].fn=&isl_val_add;
++  val_bin_op['-'].fn=&isl_val_sub;
++  val_bin_op['*'].fn=&isl_val_mul;
++  val_bin_op['/'].fn=&isl_val_div;
++  val_bin_op['g'].fn=&isl_val_gcd;
++  val_bin_op['m'].fn=&isl_val_min;
++  val_bin_op['M'].fn=&isl_val_max;
++}
+ 
+ struct {
+ 	const char *arg1;
+@@ -4344,14 +4348,18 @@
+ 	return 0;
+ }
+ 
+-struct {
++struct abo {
+ 	__isl_give isl_aff *(*fn)(__isl_take isl_aff *aff1,
+ 				__isl_take isl_aff *aff2);
+-} aff_bin_op[] = {
+-	['+'] = { &isl_aff_add },
+-	['-'] = { &isl_aff_sub },
+-	['*'] = { &isl_aff_mul },
+-	['/'] = { &isl_aff_div },
++} abo;
++struct abo aff_bin_op[256];
++
++void setup_aff_bin_ops()
++{
++  aff_bin_op['+'].fn=&isl_aff_add;
++  aff_bin_op['-'].fn=&isl_aff_sub;
++  aff_bin_op['*'].fn=&isl_aff_mul;
++  aff_bin_op['/'].fn=&isl_aff_div;
+ };
+ 
+ struct {
+@@ -6943,6 +6951,9 @@
+ 	struct isl_ctx *ctx;
+ 	struct isl_options *options;
+ 
++	setup_val_bin_ops();
++	setup_aff_bin_ops();
++
+ 	options = isl_options_new_with_defaults();
+ 	assert(options);
+ 	argc = isl_options_parse(options, argc, argv, ISL_ARG_ALL);
diff -Naur gcc-9.5.0/libatomic/config/posix/lock.c gcc-9.5.0-irix/libatomic/config/posix/lock.c
--- gcc-9.5.0/libatomic/config/posix/lock.c	2022-05-27 03:21:12.803388000 +0000
+++ gcc-9.5.0-irix/libatomic/config/posix/lock.c	2025-02-14 07:40:08.500590400 +0000
@@ -54,7 +54,8 @@
 };
 
 #define NLOCKS		(PAGE_SIZE / WATCH_SIZE)
-static struct lock locks[NLOCKS] = {
+static struct lock locks[NLOCKS] = 
+{
   [0 ... NLOCKS-1].mutex = PTHREAD_MUTEX_INITIALIZER
 };
 
diff -Naur gcc-9.5.0/libgcc/config/mips/irix-crti.S gcc-9.5.0-irix/libgcc/config/mips/irix-crti.S
--- gcc-9.5.0/libgcc/config/mips/irix-crti.S	1969-12-31 19:00:00.000000000 +0000
+++ gcc-9.5.0-irix/libgcc/config/mips/irix-crti.S	2025-02-13 08:55:07.787104800 +0000
@@ -0,0 +1,71 @@
+/* Copyright (C) 2004, 2008, 2011 Free Software Foundation, Inc.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 3, or (at your option) any later
+version.
+
+GCC is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+for more details.
+
+Under Section 7 of GPL version 3, you are granted additional
+permissions described in the GCC Runtime Library Exception, version
+3.1, as published by the Free Software Foundation.
+
+You should have received a copy of the GNU General Public License and
+a copy of the GCC Runtime Library Exception along with this program;
+see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+<http://www.gnu.org/licenses/>.  */
+
+	.abicalls
+	.set	noreorder
+	.set	nomacro
+
+/* The GNU and SGI linkers differ in their implementation of -init and -fini.
+   With the GNU linker, there can only be a single -init option, and the
+   linker simply sets DT_INIT to that value.  gcc's initialization and
+   finalization code can go directly in .init, with the prologue and
+   epilogue of the main initialization routine being provided by external
+   object files (*crti.o and *crtn.o in this case).
+
+   The SGI linker instead accepts several -init options.  It will set DT_INIT
+   to a linker-created function (placed in .init) that calls each of the -init
+   functions in turn.  If there is any user code in .init, this linker-created
+   function will be placed after it.  Note that such user code is not treated
+   specially; it will only be called if the -init options arrange for it to
+   be called.
+
+   In theory, the SGI model should allow the crti, crtn and intermediate code
+   to go in .init, just like it can with the GNU linker.  However, doing this
+   seems to confuse the linker and triggers an internal error:
+
+      ld32: FATAL   2  : Internal: at ../../ld/mips_code.c mips_code_fixup()
+	 text section overflow!
+
+   (seen with MIPSpro 7.30).  We therefore put everything in a special
+   .gcc_init section instead.  */
+
+	.section .gcc_init,"ax",@progbits
+	.globl	__gcc_init
+__gcc_init:
+	daddiu	$sp,$sp,-16
+	sd	$31,0($sp)
+	sd	$28,8($sp)
+
+	.section .gcc_fini,"ax",@progbits
+	.globl	__gcc_fini
+__gcc_fini:
+	daddiu	$sp,$sp,-16
+	sd	$31,0($sp)
+	sd	$28,8($sp)
+
+/* This object will typically be included in the final link for both
+   shared libraries and executable, and we need to hide the symbols to
+   prevent possible symbol preemption warnings from the SGI linker.  */
+.hidden __gcc_init
+.hidden __gcc_fini
+
diff -Naur gcc-9.5.0/libgcc/config/mips/irix-crtn.S gcc-9.5.0-irix/libgcc/config/mips/irix-crtn.S
--- gcc-9.5.0/libgcc/config/mips/irix-crtn.S	1969-12-31 19:00:00.000000000 +0000
+++ gcc-9.5.0-irix/libgcc/config/mips/irix-crtn.S	2025-02-13 08:55:07.789029600 +0000
@@ -0,0 +1,38 @@
+/* Copyright (C) 2004, 2011 Free Software Foundation, Inc.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 3, or (at your option) any later
+version.
+
+GCC is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+for more details.
+
+Under Section 7 of GPL version 3, you are granted additional
+permissions described in the GCC Runtime Library Exception, version
+3.1, as published by the Free Software Foundation.
+
+You should have received a copy of the GNU General Public License and
+a copy of the GCC Runtime Library Exception along with this program;
+see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+<http://www.gnu.org/licenses/>.  */
+
+	.abicalls
+	.set	noreorder
+	.set	nomacro
+
+	.section .gcc_init,"ax",@progbits
+	ld	$31,0($sp)
+	ld	$28,8($sp)
+	jr	$31
+	daddiu	$sp,$sp,16
+
+	.section .gcc_fini,"ax",@progbits
+	ld	$31,0($sp)
+	ld	$28,8($sp)
+	jr	$31
+	daddiu	$sp,$sp,16
diff -Naur gcc-9.5.0/libgcc/config/mips/irix6-unwind.h gcc-9.5.0-irix/libgcc/config/mips/irix6-unwind.h
--- gcc-9.5.0/libgcc/config/mips/irix6-unwind.h	1969-12-31 19:00:00.000000000 +0000
+++ gcc-9.5.0-irix/libgcc/config/mips/irix6-unwind.h	2025-02-13 08:55:07.791402400 +0000
@@ -0,0 +1,180 @@
+/* DWARF2 EH unwinding support for MIPS IRIX 6.
+   Copyright (C) 2011 Free Software Foundation, Inc.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+Under Section 7 of GPL version 3, you are granted additional
+permissions described in the GCC Runtime Library Exception, version
+3.1, as published by the Free Software Foundation.
+
+You should have received a copy of the GNU General Public License and
+a copy of the GCC Runtime Library Exception along with this program;
+see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+<http://www.gnu.org/licenses/>.  */
+
+/* Do code reading to identify a signal frame, and set the frame
+   state data appropriately.  See unwind-dw2.c for the structs.  */
+
+/* This code was developed-for and only tested-in limited ABI
+   configurations.  Characterize that.  */
+
+#if defined (_ABIN32) || defined (_ABI64)
+#define SUPPORTED_ABI 1
+#else
+#define SUPPORTED_ABI 0
+#endif
+
+#include <signal.h>
+
+#define MD_FALLBACK_FRAME_STATE_FOR mips_fallback_frame_state
+
+/* Look at the code around RA to see if it matches a sighandler caller with a
+   sigcontext_t * argument (SA_SIGINFO cleared).  Return that pointer argument
+   if it does match, or 0 otherwise.  */
+
+static sigcontext_t *
+sigcontext_for (unsigned int *ra, void *cfa)
+{
+  /* IRIX 6.5, mono-threaded application.  We're lucky enough to be able
+     to expect a short very sighandler specific sequence around.
+
+     <_sigtramp+124>:	li	v0,1088 (SYS_sigreturn)
+     <_sigtramp+128>:	syscall  */
+
+  if (   ra[6] == 0x24020440
+      && ra[7] == 0x0000000c)
+    return (sigcontext_t *)(cfa + 0x30);
+
+  /* IRIX 6.5 variants, multi-threaded application, pthreads.  Nothing really
+     sighandler specific handy, so match a fairly long constant sequence.  */
+
+#if _MIPS_SIM == _ABIN32
+  /* 
+     <sig_fixup_mask+40>:	sd	s0,0(sp)
+     <sig_fixup_mask+44>:	sll	ra,a0,0x2
+     <sig_fixup_mask+48>:	addiu	t9,t9,-28584/-28456/-28448
+     <sig_fixup_mask+52>:	lw	s0,3804(at)
+     <sig_fixup_mask+56>:	addu	t9,t9,ra
+     <sig_fixup_mask+60>:	lw	t9,0(t9)
+     <sig_fixup_mask+64>:	ld	at,3696(at)
+     <sig_fixup_mask+68>:	ld	s2,88(s0)
+     <sig_fixup_mask+72>:	jalr	t9
+     <sig_fixup_mask+76>:	sd	at,88(s0)  */
+   if (   ra[-10] == 0xffb00000
+      && ra[ -9] == 0x0004f880
+      && (ra[-8] == 0x27399058
+	  || ra[-8] == 0x273990d8
+	  || ra[-8] == 0x273990e0)
+      && ra[ -7] == 0x8c300edc
+      && ra[ -6] == 0x033fc821
+      && ra[ -5] == 0x8f390000
+      && ra[ -4] == 0xdc210e70
+      && ra[ -3] == 0xde120058
+      && ra[ -2] == 0x0320f809
+      && ra[ -1] == 0xfe010058)
+
+#elif _MIPS_SIM == _ABI64
+  /* 
+     <sig_fixup_mask+44>:	sd	s0,0(sp)
+     <sig_fixup_mask+48>:	daddu	t9,t9,ra
+     <sig_fixup_mask+52>:	dsll	ra,a0,0x3
+     <sig_fixup_mask+56>:	ld	s0,3880(at)
+     <sig_fixup_mask+60>:	daddu	t9,t9,ra
+     <sig_fixup_mask+64>:	ld	t9,0(t9)
+     <sig_fixup_mask+68>:	ld	at,3696(at)
+     <sig_fixup_mask+72>:	ld	s2,152(s0)
+     <sig_fixup_mask+76>:	jalr	t9
+     <sig_fixup_mask+80>:	sd	at,152(s0)  */
+  if (   ra[-10] == 0xffb00000
+      && ra[ -9] == 0x033fc82d
+      && ra[ -8] == 0x0004f8f8
+      && ra[ -7] == 0xdc300f28
+      && ra[ -6] == 0x033fc82d
+      && ra[ -5] == 0xdf390000
+      && ra[ -4] == 0xdc210e70
+      && ra[ -3] == 0xde120098
+      && ra[ -2] == 0x0320f809
+      && ra[ -1] == 0xfe010098)
+#endif
+    return (sigcontext_t *)(cfa + 0x60);
+
+  return 0;
+}
+
+#define SIGCTX_GREG_ADDR(REGNO,SIGCTX) \
+  ((void *) &(SIGCTX)->sc_regs[REGNO])
+
+#define SIGCTX_FPREG_ADDR(REGNO,SIGCTX) \
+  ((void *) &(SIGCTX)->sc_fpregs[REGNO])
+
+static _Unwind_Reason_Code
+mips_fallback_frame_state (struct _Unwind_Context *context,
+			   _Unwind_FrameState *fs)
+{
+  /* Return address and CFA of the frame we're attempting to unwind through,
+     possibly a signal handler.  */
+  void *ctx_ra  = (void *)context->ra;
+  void *ctx_cfa = (void *)context->cfa;
+
+  /* CFA of the intermediate abstract kernel frame between the interrupted
+     code and the signal handler, if we're indeed unwinding through a signal
+     handler.  */
+  void *k_cfa;
+
+  /* Pointer to the sigcontext_t structure pushed by the kernel when we're
+     unwinding through a signal handler setup with SA_SIGINFO cleared.  */
+  sigcontext_t *sigctx;
+  int i;
+
+  if (! SUPPORTED_ABI)
+    return _URC_END_OF_STACK;
+    
+  sigctx = sigcontext_for (ctx_ra, ctx_cfa);
+
+  if (sigctx == 0)
+    return _URC_END_OF_STACK;
+
+  /* The abstract kernel frame's CFA is extactly the stack pointer
+     value at the interruption point.  */
+  k_cfa = *(void **)SIGCTX_GREG_ADDR (CTX_SP, sigctx);
+
+  /* State the rules to compute the CFA we have the value of: use the
+     previous CFA and offset by the difference between the two.  See
+     uw_update_context_1 for the supporting details.  */
+  fs->regs.cfa_how = CFA_REG_OFFSET;
+  fs->regs.cfa_reg = __builtin_dwarf_sp_column ();
+  fs->regs.cfa_offset = k_cfa - ctx_cfa;
+
+  /* Fill the internal frame_state structure with information stating where
+     each register of interest can be found from the CFA.  */
+  for (i = 0; i <= 31; i ++)
+    {
+      fs->regs.reg[i].how = REG_SAVED_OFFSET;
+      fs->regs.reg[i].loc.offset = SIGCTX_GREG_ADDR (i, sigctx) - k_cfa;
+    }
+
+  for (i = 0; i <= 31; i ++)
+    {
+      fs->regs.reg[32+i].how = REG_SAVED_OFFSET;
+      fs->regs.reg[32+i].loc.offset = SIGCTX_FPREG_ADDR (i, sigctx) - k_cfa;
+    }
+
+  /* State the rules to find the kernel's code "return address", which is the
+     address of the active instruction when the signal was caught.  */
+  fs->retaddr_column = DWARF_FRAME_RETURN_COLUMN;
+  fs->regs.reg[fs->retaddr_column].how = REG_SAVED_OFFSET;
+  fs->regs.reg[fs->retaddr_column].loc.offset = (void *)&sigctx->sc_pc - k_cfa;
+  fs->signal_frame = 1;
+
+  return _URC_NO_REASON;
+}
diff -Naur gcc-9.5.0/libgcc/config/mips/sfp-machine.h gcc-9.5.0-irix/libgcc/config/mips/sfp-machine.h
--- gcc-9.5.0/libgcc/config/mips/sfp-machine.h	2022-05-27 03:21:12.899389000 +0000
+++ gcc-9.5.0-irix/libgcc/config/mips/sfp-machine.h	2025-02-13 08:55:07.799128800 +0000
@@ -22,6 +22,8 @@
 see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 <http://www.gnu.org/licenses/>.  */
 
+#if !defined(__sgi)
+
 #ifdef __mips64
 #define _FP_W_TYPE_SIZE		64
 #define _FP_W_TYPE		unsigned long long
@@ -190,3 +192,5 @@
 # define strong_alias(name, aliasname) _strong_alias(name, aliasname)
 # define _strong_alias(name, aliasname) \
   extern __typeof (name) aliasname __attribute__ ((alias (#name)));
+
+#endif /* !defined(__sgi) */
diff -Naur gcc-9.5.0/libgcc/config/mips/t-irix6 gcc-9.5.0-irix/libgcc/config/mips/t-irix6
--- gcc-9.5.0/libgcc/config/mips/t-irix6	1969-12-31 19:00:00.000000000 +0000
+++ gcc-9.5.0-irix/libgcc/config/mips/t-irix6	2025-02-13 08:55:07.800968000 +0000
@@ -0,0 +1,24 @@
+# Copyright (C) 1995, 1996, 1997, 1998, 2000, 2001, 2002, 2003, 2004, 2005,
+# 2006, 2010, 2011 Free Software Foundation, Inc.
+#
+# This file is part of GCC.
+#
+# GCC is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3, or (at your option)
+# any later version.
+#
+# GCC is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GCC; see the file COPYING3.  If not see
+# <http://www.gnu.org/licenses/>.
+
+irix-crti.o: $(srcdir)/config/mips/irix-crti.S
+	$(crt_compile) -c $<
+
+irix-crtn.o: $(srcdir)/config/mips/irix-crtn.S
+	$(crt_compile) -c $<
diff -Naur gcc-9.5.0/libgcc/config/mips/t-mips-irixfp gcc-9.5.0-irix/libgcc/config/mips/t-mips-irixfp
--- gcc-9.5.0/libgcc/config/mips/t-mips-irixfp	1969-12-31 19:00:00.000000000 +0000
+++ gcc-9.5.0-irix/libgcc/config/mips/t-mips-irixfp	2025-02-13 08:55:07.802727200 +0000
@@ -0,0 +1,13 @@
+LIB2_SIDITI_CONV_FUNCS = yes
+
+FPBIT = true
+FPBIT_CFLAGS = -DQUIET_NAN_NEGATED
+DPBIT = true
+FPBIT_CFLAGS = -DQUIET_NAN_NEGATED
+
+ifeq ($(long_double_type_size),128)
+TPBIT = true
+TPBIT_CFLAGS = -DQUIET_NAN_NEGATED
+endif
+
+LIB2ADD_ST += $(srcdir)/config/mips/lib2funcs.c
diff -Naur gcc-9.5.0/libgcc/config/mips/t-slibgcc-irix gcc-9.5.0-irix/libgcc/config/mips/t-slibgcc-irix
--- gcc-9.5.0/libgcc/config/mips/t-slibgcc-irix	1969-12-31 19:00:00.000000000 +0000
+++ gcc-9.5.0-irix/libgcc/config/mips/t-slibgcc-irix	2025-02-13 08:55:07.810678400 +0000
@@ -0,0 +1,9 @@
+# Build a shared libgcc library with the SGI linker.
+
+SHLIB_LDFLAGS = -Wl,-soname,$(SHLIB_SONAME) 
+#\
+	#-Wl,-exports_file,$(SHLIB_MAP)
+
+SHLIB_MKMAP = $(srcdir)/mkmap-flat.awk
+SHLIB_MAPFILES = libgcc-std.ver
+SHLIB_LC =
diff -Naur gcc-9.5.0/libgcc/config.host gcc-9.5.0-irix/libgcc/config.host
--- gcc-9.5.0/libgcc/config.host	2022-05-27 03:21:12.855388000 +0000
+++ gcc-9.5.0-irix/libgcc/config.host	2025-02-13 08:55:07.829696000 +0000
@@ -146,6 +146,15 @@
 microblaze*-*-*)
 	cpu_type=microblaze
 	;;
+mips-sgi-irix6.5*)
+	# All MIPS targets provide a full set of FP routines.
+	cpu_type=mips
+	tmake_file="mips/t-mips-irixfp"
+	# This doesn't work yet
+	if test "${host_address}" = 64; then
+		tmake_file="${tmake_file} mips/t-mips-irixfp64"
+	fi
+	;;
 mips*-*-*)
 	# All MIPS targets provide a full set of FP routines.
 	cpu_type=mips
@@ -914,6 +923,11 @@
 	tmake_file="${tmake_file} microblaze/t-microblaze t-fdpbit"
 	extra_parts="$extra_parts crtbeginS.o crtendS.o crtbeginT.o crti.o crtn.o"
 	;;
+mips-sgi-irix6.5*)
+	tmake_file="$tmake_file mips/t-irix6 t-crtfm mips/t-tpbit t-slibgcc mips/t-slibgcc-irix"
+	extra_parts="crtbegin.o crtend.o crtfastmath.o irix-crti.o irix-crtn.o"
+	md_unwind_header=mips/irix6-unwind.h
+	;;
 microblaze*-*-rtems*)
 	tmake_file="${tmake_file} microblaze/t-microblaze t-fdpbit"
 	extra_parts="$extra_parts crtbeginS.o crtendS.o crtbeginT.o crti.o crtn.o"
diff -Naur gcc-9.5.0/libgcc/libgcov-driver-system.c gcc-9.5.0-irix/libgcc/libgcov-driver-system.c
--- gcc-9.5.0/libgcc/libgcov-driver-system.c	2022-05-27 03:21:12.915389000 +0000
+++ gcc-9.5.0-irix/libgcc/libgcov-driver-system.c	2025-02-13 08:55:07.832601600 +0000
@@ -158,7 +158,7 @@
 	  switch (*p)
 	    {
 	    case 'p':
-	      sprintf (buffer, "%d", getpid ());
+	      sprintf (buffer, "%ld", getpid ());
 	      replacement = buffer;
 	      p++;
 	      break;
diff -Naur gcc-9.5.0/libgomp/affinity-fmt.c gcc-9.5.0-irix/libgomp/affinity-fmt.c
--- gcc-9.5.0/libgomp/affinity-fmt.c	2022-05-27 03:21:13.143390000 +0000
+++ gcc-9.5.0-irix/libgomp/affinity-fmt.c	2025-02-13 11:39:06.266232000 +0000
@@ -383,15 +383,10 @@
 
 	    if (sizeof (gomp_integral (handle)) == sizeof (unsigned long))
 	      sprintf (buf, "0x%lx", (unsigned long) gomp_integral (handle));
-#if defined (HAVE_INTTYPES_H) && defined (PRIx64)
-	    else if (sizeof (gomp_integral (handle)) == sizeof (uint64_t))
-	      sprintf (buf, "0x%" PRIx64, (uint64_t) gomp_integral (handle));
-#else
 	    else if (sizeof (gomp_integral (handle))
 		     == sizeof (unsigned long long))
 	      sprintf (buf, "0x%llx",
 		       (unsigned long long) gomp_integral (handle));
-#endif
 	    else
 	      sprintf (buf, "0x%x", (unsigned int) gomp_integral (handle));
 	    gomp_display_num (buffer, size, &ret, zero, right, sz, buf);
diff -Naur gcc-9.5.0/libgomp/config/posix/proc.c gcc-9.5.0-irix/libgomp/config/posix/proc.c
--- gcc-9.5.0/libgomp/config/posix/proc.c	2022-05-27 03:21:13.147390000 +0000
+++ gcc-9.5.0-irix/libgomp/config/posix/proc.c	2025-02-13 08:58:14.622660000 +0000
@@ -38,6 +38,9 @@
 # endif
 #endif
 
+#ifdef __sgi
+#define _SC_NPROCESSORS_ONLN _SC_NPROC_ONLN
+#endif
 
 /* At startup, determine the default number of threads.  It would seem
    this should be related to the number of cpus online.  */
diff -Naur gcc-9.5.0/libgomp/configure.tgt gcc-9.5.0-irix/libgomp/configure.tgt
--- gcc-9.5.0/libgomp/configure.tgt	2022-05-27 03:21:13.147390000 +0000
+++ gcc-9.5.0-irix/libgomp/configure.tgt	2025-02-13 08:55:07.839636000 +0000
@@ -145,6 +145,11 @@
 	XLDFLAGS="${XLDFLAGS} -lpthread"
 	;;
 
+  mips-sgi-irix6.5*)
+       # Need to link with -lpthread so libgomp.so is self-contained.
+       XLDFLAGS="${XLDFLAGS} -lpthread"
+       ;;
+
   *-*-aix*)
 	config_path="posix"
 	# Need to link with -lpthread so libgomp.so is self-contained.
diff -Naur gcc-9.5.0/libgomp/env.c gcc-9.5.0-irix/libgomp/env.c
--- gcc-9.5.0/libgomp/env.c	2022-05-27 03:21:13.147390000 +0000
+++ gcc-9.5.0-irix/libgomp/env.c	2025-02-13 11:40:44.889941600 +0000
@@ -1281,13 +1281,8 @@
     {
       fputs ("  GOMP_CPU_AFFINITY = ''\n", stderr);
       fprintf (stderr, "  GOMP_STACKSIZE = '%lu'\n", stacksize);
-#ifdef HAVE_INTTYPES_H
-      fprintf (stderr, "  GOMP_SPINCOUNT = '%"PRIu64"'\n",
-	       (uint64_t) gomp_spin_count_var);
-#else
       fprintf (stderr, "  GOMP_SPINCOUNT = '%lu'\n",
 	       (unsigned long) gomp_spin_count_var);
-#endif
     }
 
   fputs ("OPENMP DISPLAY ENVIRONMENT END\n", stderr);
diff -Naur gcc-9.5.0/libgomp/oacc-parallel.c gcc-9.5.0-irix/libgomp/oacc-parallel.c
--- gcc-9.5.0/libgomp/oacc-parallel.c	2022-05-27 03:21:13.151390000 +0000
+++ gcc-9.5.0-irix/libgomp/oacc-parallel.c	2025-02-13 11:41:29.937189600 +0000
@@ -140,13 +140,8 @@
   unsigned dims[GOMP_DIM_MAX];
   unsigned tag;
 
-#ifdef HAVE_INTTYPES_H
-  gomp_debug (0, "%s: mapnum=%"PRIu64", hostaddrs=%p, size=%p, kinds=%p\n",
-	      __FUNCTION__, (uint64_t) mapnum, hostaddrs, sizes, kinds);
-#else
   gomp_debug (0, "%s: mapnum=%lu, hostaddrs=%p, sizes=%p, kinds=%p\n",
 	      __FUNCTION__, (unsigned long) mapnum, hostaddrs, sizes, kinds);
-#endif
   goacc_lazy_initialize ();
 
   thr = goacc_thread ();
@@ -297,13 +292,8 @@
 
   struct target_mem_desc *tgt;
 
-#ifdef HAVE_INTTYPES_H
-  gomp_debug (0, "%s: mapnum=%"PRIu64", hostaddrs=%p, size=%p, kinds=%p\n",
-	      __FUNCTION__, (uint64_t) mapnum, hostaddrs, sizes, kinds);
-#else
   gomp_debug (0, "%s: mapnum=%lu, hostaddrs=%p, sizes=%p, kinds=%p\n",
 	      __FUNCTION__, (unsigned long) mapnum, hostaddrs, sizes, kinds);
-#endif
 
   goacc_lazy_initialize ();
 
diff -Naur gcc-9.5.0/libgomp/target.c gcc-9.5.0-irix/libgomp/target.c
--- gcc-9.5.0/libgomp/target.c	2022-05-27 03:21:13.155390000 +0000
+++ gcc-9.5.0-irix/libgomp/target.c	2025-02-13 11:38:48.329337600 +0000
@@ -932,16 +932,9 @@
 			 was missing.  */
 		      size_t size = k->host_end - k->host_start;
 		      gomp_mutex_unlock (&devicep->lock);
-#ifdef HAVE_INTTYPES_H
-		      gomp_fatal ("present clause: !acc_is_present (%p, "
-				  "%"PRIu64" (0x%"PRIx64"))",
-				  (void *) k->host_start,
-				  (uint64_t) size, (uint64_t) size);
-#else
 		      gomp_fatal ("present clause: !acc_is_present (%p, "
 				  "%lu (0x%lx))", (void *) k->host_start,
 				  (unsigned long) size, (unsigned long) size);
-#endif
 		    }
 		    break;
 		  case GOMP_MAP_FORCE_DEVICEPTR:
diff -Naur gcc-9.5.0/libstdc++-v3/acinclude.m4 gcc-9.5.0-irix/libstdc++-v3/acinclude.m4
--- gcc-9.5.0/libstdc++-v3/acinclude.m4	2022-05-27 03:21:13.311391000 +0000
+++ gcc-9.5.0-irix/libstdc++-v3/acinclude.m4	2025-02-13 08:55:08.101274400 +0000
@@ -276,7 +276,7 @@
     AC_MSG_CHECKING([for ld that supports -Wl,-z,relro])
     cxx_z_relo=`$LD -v --help 2>/dev/null | grep "z relro"`
     if test -n "$cxx_z_relo"; then
-      OPT_LDFLAGS="-Wl,-z,relro"
+      OPT_LDFLAGS="-Wl,-z,relro $OPT_LDFLAGS"
       ac_ld_relro=yes
     fi
     AC_MSG_RESULT($ac_ld_relro)
diff -Naur gcc-9.5.0/libstdc++-v3/config/os/irix/atomic_word.h gcc-9.5.0-irix/libstdc++-v3/config/os/irix/atomic_word.h
--- gcc-9.5.0/libstdc++-v3/config/os/irix/atomic_word.h	1969-12-31 19:00:00.000000000 +0000
+++ gcc-9.5.0-irix/libstdc++-v3/config/os/irix/atomic_word.h	2025-02-13 08:55:07.841889600 +0000
@@ -0,0 +1,35 @@
+// Low-level type for atomic operations -*- C++ -*-
+
+// Copyright (C) 2004, 2009, 2010 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// Under Section 7 of GPL version 3, you are granted additional
+// permissions described in the GCC Runtime Library Exception, version
+// 3.1, as published by the Free Software Foundation.
+
+// You should have received a copy of the GNU General Public License and
+// a copy of the GCC Runtime Library Exception along with this program;
+// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+// <http://www.gnu.org/licenses/>.
+
+/** @file bits/atomic_word.h
+ *  This is an internal header file, included by other library headers.
+ *  Do not attempt to use it directly. @headername{ext/atomicity.h}
+ */
+
+#ifndef _GLIBCXX_ATOMIC_WORD_H
+#define _GLIBCXX_ATOMIC_WORD_H	1
+
+typedef long _Atomic_word;
+
+#endif 
diff -Naur gcc-9.5.0/libstdc++-v3/config/os/irix/atomicity.h gcc-9.5.0-irix/libstdc++-v3/config/os/irix/atomicity.h
--- gcc-9.5.0/libstdc++-v3/config/os/irix/atomicity.h	1969-12-31 19:00:00.000000000 +0000
+++ gcc-9.5.0-irix/libstdc++-v3/config/os/irix/atomicity.h	2025-02-13 08:55:07.843772800 +0000
@@ -0,0 +1,41 @@
+// Low-level functions for atomic operations: IRIX version  -*- C++ -*-
+
+// Copyright (C) 2001, 2004, 2005, 2009 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// Under Section 7 of GPL version 3, you are granted additional
+// permissions described in the GCC Runtime Library Exception, version
+// 3.1, as published by the Free Software Foundation.
+
+// You should have received a copy of the GNU General Public License and
+// a copy of the GCC Runtime Library Exception along with this program;
+// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+// <http://www.gnu.org/licenses/>.
+
+#include <mutex.h>
+#include <ext/atomicity.h>
+
+namespace __gnu_cxx _GLIBCXX_VISIBILITY(default)
+{
+_GLIBCXX_BEGIN_NAMESPACE_VERSION
+
+  _Atomic_word
+  __exchange_and_add(volatile _Atomic_word* __mem, int __val) throw ()
+  { return (_Atomic_word) test_then_add((unsigned long*) const_cast<_Atomic_word*>(__mem), __val); }
+
+  void
+  __atomic_add(volatile _Atomic_word* __mem, int __val) throw ()
+  { __exchange_and_add(__mem, __val); }
+
+_GLIBCXX_END_NAMESPACE_VERSION
+} // namespace
